"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
require("whatwg-fetch");
var effects_1 = require("redux-saga/effects");
var pipe = require("ramda/src/pipe");
var isEmpty = require("ramda/src/isEmpty");
var Method;
(function (Method) {
    Method["GET"] = "GET";
    Method["POST"] = "POST";
    Method["PUT"] = "PUT";
    Method["DELETE"] = "DELETE";
    Method["PATCH"] = "PATCH";
})(Method = exports.Method || (exports.Method = {}));
var ContentType;
(function (ContentType) {
    ContentType["FormUrlencoded"] = "application/x-www-form-urlencoded";
    ContentType["JSON"] = "application/json";
    ContentType["Multipart"] = "multipart/form-data";
})(ContentType = exports.ContentType || (exports.ContentType = {}));
exports.BodyParsers = {
    json: function (body) {
        return JSON.stringify(body);
    },
    queryString: function (body) {
        if (!body) {
            return "";
        }
        var str = "";
        for (var v in body) {
            if (body.hasOwnProperty(v)) {
                str += v + "=" + encodeURIComponent(body[v]) + "&";
            }
        }
        return str.substr(0, str.length - 1);
    }
};
var HttpRequestError = (function () {
    function HttpRequestError(message, status, response) {
        if (response === void 0) { response = {}; }
        this.name = "HttpRequestError";
        this.stack = (new Error()).stack;
        this.message = message;
        this.status = status;
        this.response = response;
    }
    return HttpRequestError;
}());
exports.HttpRequestError = HttpRequestError;
var HttpRequestBuilder = (function () {
    function HttpRequestBuilder() {
        this.query = {};
        this.middleware = [];
        this.requestInit = {
            headers: {},
            credentials: "same-origin",
        };
    }
    HttpRequestBuilder.prototype.setMethod = function (x) {
        this.requestInit.method = x;
        return this;
    };
    HttpRequestBuilder.prototype.getMethod = function () {
        return this.requestInit.method;
    };
    HttpRequestBuilder.prototype.setCredentials = function (x) {
        this.requestInit.credentials = x;
        return this;
    };
    HttpRequestBuilder.prototype.getCredentials = function () {
        return this.requestInit.credentials;
    };
    HttpRequestBuilder.prototype.setContentType = function (x) {
        this.requestInit.headers["Content-Type"] = x;
        return this;
    };
    HttpRequestBuilder.prototype.getContentType = function () {
        return this.requestInit.headers["Content-Type"];
    };
    HttpRequestBuilder.prototype.setAcceptType = function (x) {
        this.requestInit.headers.Accept = x;
        return this;
    };
    HttpRequestBuilder.prototype.getAcceptType = function () {
        return this.requestInit.headers.Accept;
    };
    HttpRequestBuilder.prototype.setAuthorization = function (x) {
        this.requestInit.headers.Authorization = x;
        return this;
    };
    HttpRequestBuilder.prototype.getAuthorization = function () {
        return this.requestInit.headers.Authorization;
    };
    HttpRequestBuilder.prototype.setUrl = function (x) {
        this.url = x;
        return this;
    };
    HttpRequestBuilder.prototype.getUrl = function () {
        return this.url;
    };
    HttpRequestBuilder.prototype.setQuery = function (x) {
        this.query = x;
        return this;
    };
    HttpRequestBuilder.prototype.getQuery = function () {
        return this.query;
    };
    HttpRequestBuilder.prototype.setBody = function (x) {
        this.requestInit.body = x;
        return this;
    };
    HttpRequestBuilder.prototype.getBody = function () {
        return this.requestInit.body;
    };
    HttpRequestBuilder.prototype.applyBodyParserMiddleware = function (middleware) {
        if (Array.isArray(middleware) && middleware.length > 0) {
            this.middleware = middleware;
        }
        else if (typeof middleware === "function") {
            this.middleware = this.middleware.concat([middleware]);
        }
        return this;
    };
    HttpRequestBuilder.prototype.setRequestInit = function (x) {
        this.requestInit = x;
        return this;
    };
    HttpRequestBuilder.prototype.getRequestInit = function () {
        return this.requestInit;
    };
    HttpRequestBuilder.prototype.setRequestExtraConfig = function (x) {
        this.requestInit = __assign({}, this.requestInit, x);
        return this;
    };
    HttpRequestBuilder.prototype.build = function () {
        this.execBodyParserMiddleware();
        var url = this.url + (!isEmpty(this.query) ? ("?" + exports.BodyParsers.queryString(this.query)) : "");
        return fetch(url, this.requestInit);
    };
    HttpRequestBuilder.prototype.toResult = function (getBody) {
        if (getBody === void 0) { getBody = function (response) { return response.json(); }; }
        var requestPromise = this.build();
        return requestPromise.then(function (response) {
            var result = {
                status: response.status,
                statusText: response.statusText,
            };
            return getBody(response).then(function (data) {
                result.data = data;
                return result;
            }).catch(function (error) {
                result.error = error;
                return result;
            });
        }).catch(function (error) { return (__assign({}, error)); });
    };
    HttpRequestBuilder.prototype.execBodyParserMiddleware = function () {
        this.requestInit.body = pipe.apply(void 0, this.middleware)(this.requestInit.body);
    };
    return HttpRequestBuilder;
}());
exports.HttpRequestBuilder = HttpRequestBuilder;
function fetchSaga(request, response) {
    return function saga(action) {
        var store, callbackAction, _a, _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0: return [4, effects_1.select()];
                case 1:
                    store = _c.sent();
                    _a = effects_1.call;
                    _b = [response];
                    return [4, effects_1.call(request, action, store)];
                case 2: return [4, _a.apply(void 0, _b.concat([_c.sent()]))];
                case 3:
                    callbackAction = _c.sent();
                    if (!callbackAction) return [3, 5];
                    return [4, effects_1.put(callbackAction)];
                case 4:
                    _c.sent();
                    _c.label = 5;
                case 5: return [2];
            }
        });
    };
}
exports.fetchSaga = fetchSaga;
//# sourceMappingURL=index.js.map